package jalview.gui;

import jalview.jbgui.GFontChooser;
import jalview.gui.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class FontChooser extends GFontChooser
{
  AlignmentPanel ap;
  Font oldFont;
  boolean init = true;
  JInternalFrame frame;

  public FontChooser(AlignmentPanel ap, JInternalFrame f)
  {
    this.ap = ap;
    frame = f;
    String fonts[] = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
    for(int i=0; i<fonts.length; i++)
      fontName.addItem(fonts[i]);

    for(int i=1; i<31; i++)
      fontSize.addItem(i+"");

   fontStyle.addItem("plain");
   fontStyle.addItem("bold");
   fontStyle.addItem("italic");

   oldFont = ap.av.getFont();
   fontName.setSelectedItem(oldFont.getName());
   fontSize.setSelectedItem(oldFont.getSize()+"");
   fontStyle.setSelectedIndex(oldFont.getStyle());

   init = false;
  }

  protected void ok_actionPerformed(ActionEvent e)
  {
    try{
      frame.setClosed(true);
    }catch(Exception ex){}

   jalview.bin.Cache.setProperty("FONT_NAME", fontName.getSelectedItem().toString());
   jalview.bin.Cache.setProperty("FONT_STYLE", fontStyle.getSelectedIndex()+"");
   jalview.bin.Cache.setProperty("FONT_SIZE", fontSize.getSelectedItem().toString());
  }

  protected void cancel_actionPerformed(ActionEvent e)
  {
    ap.av.setFont(oldFont);
    ap.RefreshPanels();
    fontName.setSelectedItem(oldFont.getName());
    fontSize.setSelectedItem(oldFont.getSize()+"");
    fontStyle.setSelectedIndex(oldFont.getStyle());
  }

  void changeFont()
  {
    Font newFont = new Font(fontName.getSelectedItem().toString(),
                            fontStyle.getSelectedIndex(),
                            Integer.parseInt(fontSize.getSelectedItem().toString())
                            );
    ap.av.setFont(newFont);
    ap.annotationPanel.adjustPanelHeight();
    ap.repaint();
  }

  protected void fontName_actionPerformed(ActionEvent e)
  {
    if(init) return;
    changeFont();
  }

  protected void fontSize_actionPerformed(ActionEvent e)
  {
    if(init) return;
    changeFont();
  }

  protected void fontStyle_actionPerformed(ActionEvent e)
  {
    if(init) return;
    changeFont();
  }


}
